Index: palm/trunk/SOURCE/user_module.f90
===================================================================
--- palm/trunk/SOURCE/user_module.f90	(revision 4516)
+++ palm/trunk/SOURCE/user_module.f90	(revision 4517)
@@ -21,8 +21,11 @@
 ! -----------------
 ! 
-!
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+!
+! 4504 2020-04-20 12:11:24Z raasch
 ! hint for setting rmask arrays added
 ! 
@@ -207,5 +210,6 @@
 
     INTERFACE user_rrd_local
-       MODULE PROCEDURE user_rrd_local
+       MODULE PROCEDURE user_rrd_local_ftn
+       MODULE PROCEDURE user_rrd_local_mpi
     END INTERFACE user_rrd_local
 
@@ -1130,4 +1134,7 @@
  SUBROUTINE user_rrd_global_mpi
 
+!    USE restart_data_mpi_io_mod,                                                                   &
+!        ONLY:  rrd_mpi_io
+
 !    CALL rrd_mpi_io( 'global_parameter', global_parameter )
     CONTINUE
@@ -1139,11 +1146,12 @@
 ! Description:
 ! ------------
-!> Reading processor specific restart data from file(s) that has been defined by the user. Subdomain
+!> Read module-specific local restart data arrays (Fortran binary format).
+!> Subdomain
 !> index limits on file are given by nxl_on_file, etc. Indices nxlc, etc. indicate the range of
 !> gridpoints to be mapped from the subdomain on file (f) to the subdomain of the current PE (c).
 !> They have been calculated in routine rrd_local.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE user_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc, nxr_on_file, nynf, nync,       &
-                            nyn_on_file, nysf, nysc, nys_on_file, tmp_3d, found )
+ SUBROUTINE user_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc, nxr_on_file, nynf, nync,   &
+                                nyn_on_file, nysf, nysc, nys_on_file, tmp_3d, found )
 
 
@@ -1194,5 +1202,26 @@
     END SELECT
 
- END SUBROUTINE user_rrd_local
+ END SUBROUTINE user_rrd_local_ftn
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE user_rrd_local_mpi
+
+!    USE restart_data_mpi_io_mod,                                                                   &
+!        ONLY:  rd_mpi_io_check_array, rrd_mpi_io
+
+!    CALL rd_mpi_io_check_array( 'u2_av' , found = array_found )
+!    IF ( array_found )  THEN
+!       IF ( .NOT. ALLOCATED( u2_av ) )  ALLOCATE( u2_av(nysg:nyng,nxlg:nxrg) )
+!       CALL rrd_mpi_io( 'rad_u2_av', rad_u2_av )
+!    ENDIF
+
+    CONTINUE
+
+ END SUBROUTINE user_rrd_local_mpi
 
 
@@ -1203,4 +1232,7 @@
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE user_wrd_global
+
+!    USE restart_data_mpi_io_mod,                                                                   &
+!        ONLY:  wrd_mpi_io
 
     IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
@@ -1224,4 +1256,7 @@
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE user_wrd_local
+
+!    USE restart_data_mpi_io_mod,                                                                   &
+!        ONLY:  wrd_mpi_io
 
 !
